# 2 Built-in Types, Exceptions and Functions

Names for built-in exceptions and functions are found in a separate symbol table. This table is searched last when the interpreter looks up the meaning of a name, so local and global user-defined names can override built-in names. Built-in types are described together here for easy reference.

The tables in this chapter document the priorities of operators by listing them in order of ascending priority (within a table) and grouping operators that have the same priority in the same box. Binary operators of the same priority group from left to right. (Unary operators group from right to left, but there you have no real choice.) See Chapter 5 of the Python Reference Manual for the complete picture on operator priorities.

- 2.1 Built-in Types
  - 2.1.1 Truth Value Testing
  - 2.1.2 Boolean Operations
  - 2.1.3 Comparisons
  - 2.1.4 Numeric Types
    - Bit-string Operations on Integer Types
  - 2.1.5 Sequence Types
    - More String Operations
    - Mutable Sequence Types
  - 2.1.6 Mapping Types
  - 2.1.7 Other Built-in Types
    - Modules
    - Classes and Class Instances
    - Functions
    - Methods
    - Code Objects
    - Type Objects
    - The Null Object
    - File Objects
    - Internal Objects
  - 2.1.8 Special Attributes
- 2.2 Built-in Exceptions
- 2.3 Built-in Functions